using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace ApplicationNamespace
{
    public class $safeitemname$ : IDisposable
    {
        private bool started = false;
        private RenderTarget2D renderTarget;
        private Color clearcolor = Color.Black;
        private GraphicsDevice device;

      
        public GraphicsDevice GraphicsDevice
        {
            get { return device; }
            set { device = value; }
        }           

        public Color ClearColor
        {
            get { return clearcolor; }
            set { clearcolor = value; }
        }

        public int Height
        {
            get { return this.renderTarget.Height; }
        }

        public int Width
        {
            get { return this.renderTarget.Width; }
        }

        public $safeitemname$(GraphicsDevice dev, int w, int h)
        {
            this.device = dev;
            this.renderTarget = new RenderTarget2D(this.device, w, h, 0, SurfaceFormat.Color);
        }

        public Texture2D GetTexture()
        {
            return renderTarget.GetTexture();
        }

        public void Begin()
        {
            if (this.started) return;
            this.started = true;
            this.device.SetRenderTarget(0, renderTarget);
            this.device.Clear(this.clearcolor); 
        }

        public void End()
        {
            if (!this.started) return;
            this.device.ResolveRenderTarget(0);
            this.device.SetRenderTarget(0, null);    
            this.started = false;
        }

        #region IDisposable Members
        private bool isDisposed = false;

        public bool IsDisposed
        {
            get { return isDisposed; }
        }
	
        public void Dispose()
        {
            this.device = null;
            this.renderTarget.Dispose();
            this.renderTarget = null;
            this.isDisposed = true;
        }

        #endregion
    }
}
